Polymer({
	is:"dd-login-window",
	properties:{
		loginName:{notify:true},
		mobile:{observer:"screenSizeChanged"}
	},
	ready:function(){
		this.error = false;
		this.loggingIn = false;
	},
	callLogin:function(){
		this.loggingIn = true;
		this.$.ajaxLoginUser.body = JSON.stringify({"USERNAME":this.username,
													"PASSWORD":this.password});
		this.$.ajaxLoginUser.generateRequest();
	},
	failedLogin:function(){
		this.error = true;
	},
	ajaxLoginUserResponse:function(){
		if(this.loggedIn == true) {
			this.loginName = this.username;
			this.error = false;
			this.loggingIn = false;
			document.getElementById("pageSelector").selected = 1;
			document.getElementById("fileBrowser").loginName = this.username;
		}
		else {
			this.error = true;
		}
	},
	resetLogin:function(){
		this.error = false;
		this.loggedIn = false;
		this.loggingIn = false;
	},
	detectEnterPress:function(e){
		if(e.which == 13) {
			this.callLogin();
		}
	},
	screenSizeChanged:function(){
		if(this.mobile === true) {
			this.loginBox = "login-box-mobile";
			this.imageLeft = "bottom-left-image-mobile";
			this.imageRight = "top-right-image-mobile";
		}
		else {
			this.loginBox = "login-box";
			this.imageLeft = "bottom-left-image";
			this.imageRight = "top-right-image";
		}
	}
});	