<?php
	require_once(getcwd()."/protected/lib/core.php");
	require_once(getcwd()."/protected/lib/video.php");
	require_once(getcwd()."/protected/config/main.php");
	function actionReturnHash(){
		$password = arrayGet($_GET, "PASSWORD");
		$password = $password.Salt();
		$password = hash('sha256', $password);
		echo $password;
	}
	function actionStreamItem(){
		valRequestMethodGet();
		$folderPath = arrayGet($_GET,"FOLDERPATH");
		$folderPath = str_replace("//","/",$folderPath);
		$folderPath = str_replace("%20"," ",$folderPath);
		$ext = arrayGet($_GET, "EXT");
		if(validateLoggedIn($_SESSION['USERNAME'])){
			$path = CoreFilePath().'/'.$_SESSION['USERNAME'].'/'.$folderPath;
			//$path = "https://24.11.62.180/dropFilesBackend/FILES/wesleywh/".$folderPath;
			$mimeType = mimeTypeForExtension($ext);
			$stream = new VideoStream($path, $mimeType);
			$stream->start();exit;
		}
	}
	function actionCheckLogin(){
		valRequestMethodGet();
		session_set_cookie_params(3600,"/");
		if (isset($_SESSION['USERNAME'])) {
			if(!is_null($_SESSION['USERNAME']) || $_SESSION['USERNAME'] != '') {
				$username = (string)$_SESSION['USERNAME'];
				$queryResult = queryDB("SELECT ACTIVE FROM login_status WHERE USERNAME = '$username'");
				$queryResult = strToBool($queryResult['ACTIVE']); //convert number to boolean
				$result['STATUS'] = ($queryResult) ? 'true' : 'false'; //convert boolean to string (interpret 1 as "true")
				$result['USERNAME'] = $username;
			}
			else {
				$result['STATUS'] = 'false';
			}
		}
		else {
			$_SESSION['USERNAME'] = '';
			$result['STATUS'] = 'false';
		}
		echo jsonEncodePlus($result);
	}
	function actionLogoutUser(){
		valRequestMethodPost();
		$username = $_SESSION['USERNAME'];
		$result = queryDB("SELECT * FROM users WHERE USERNAME='$username'");
		$result = queryDB("UPDATE login_status SET ACTIVE='0' WHERE USERNAME='$username'");
		session_destroy();
		echo "Succesfully Logged Out";
	}
	function actionChangeUserPassword(){
		valRequestMethodPost();
		$body = inputGetJsonDecode();
		$password = arrayGet($body, "PASSWORD");
		$password = $password.Salt();
		$password = hash('sha256', $password);
		$username = $_SESSION['USERNAME'];
		if(validateLoggedIn($username)){
			$result = queryDB("UPDATE users SET PASSWORD='$password' WHERE USERNAME='$username'");
			echo "Succesfully Changed Password";
		}
		else {
			echo "Not Logged In";
		}
	}
	function actionLoginUser(){
		valRequestMethodPost();
		$body = inputGetJsonDecode();
		$username = arrayGet($body,"USERNAME");
		$password = arrayGet($body,"PASSWORD");
		$password = $password.Salt();
		$password = hash('sha256', $password);
		$result = queryDB("SELECT * FROM users WHERE USERNAME='$username'");
		if($result['USERNAME'] == $username && $result['PASSWORD'] == $password) {
			$result = queryDB("UPDATE login_status SET ACTIVE='1' WHERE USERNAME='$username'");
			$_SESSION['USERNAME'] = $username;
			echo "true";
		}
		else {
			$_SESSION['USERNAME'] = '';
			echo "false";
		}
	}
	function actionGetFilesInFolder(){
		valRequestMethodGet();
		$username = arrayGet($_GET,"USERNAME");
		$folder = arrayGet($_GET,"FOLDER");
		if(validateLoggedIn($username)){
			if($folder == '/'){
				$folder = '/'.$username;
			}
			else {
				$finalFolder = '/'.$username.'/'.$folder;
				$folder = $finalFolder;
			}
			$allFiles = scandir(CoreFilePath().'/'.$folder);
			$files = array_values(array_diff($allFiles, array('.', '..')));

			$result = [];
			for($i=0; $i<sizeOf($files); $i++) {
				$result[$i]['FILENAME'] = $files[$i];
				$result[$i]['EXT'] = substr(strrchr($files[$i], '.'), 1);
				$date = filemtime(CoreFilePath().'/'.$folder."/".$files[$i]);
				$result[$i]['DATE'] = date('F d Y h:i A', $date);
				$result[$i]['ID'] = "ID".$i."-".$result[$i]['FILENAME'];
				$result[$i]['INPUTID'] = "INPUTID".$i."-".$result[$i]['FILENAME'];
				$result[$i]['TYPE'] = filetype(CoreFilePath().'/'.$folder."/".$files[$i]);
			}
			echo jsonEncodePlus($result);
		}
		else {
			echo "Error: User $username Not Logged In.";
		}
	}
	function validateLoggedIn($user) {
		$result = queryDB("SELECT ACTIVE FROM login_status WHERE USERNAME = '$user'");
		$result = strToBool($result['ACTIVE']); 
		$result = ($result) ? 'true' : 'false';
		return $result;
	}
	function actionDeleteFolder(){
		valRequestMethodPost();
		if(validateLoggedIn($_SESSION['USERNAME']) == true) {
			$body = inputGetJsonDecode();
			$fileName = arrayGet($body,"FILENAME");
			$path = arrayGet($body,"FILEPATH");
			$filePath = CoreFilePath();
			$filePath .="/".$_SESSION['USERNAME']."".$path.$fileName;
			removeDirectory($filePath);
			echo "Success";
		}
		else {
			echo "Not Logged In";
		}
	}
	function actionAddNewFolder(){
		valRequestMethodPost();
		if(validateLoggedIn($_SESSION['USERNAME']) == true) {
			$body = inputGetJsonDecode();
			$folder = arrayGet($body,"FOLDER");
			$path = arrayGet($body,"PATH");

			$folderPath = CoreFilePath();
			$folderPath .= "/".$_SESSION['USERNAME']."".$path."/".$folder;

			if(file_exists($folderPath)){
				echo "Error: Filename already exists in directory";
			}
			else{
				mkdir($folderPath, 0744);
				chmod ($folderPath , 0744);
				echo "Success";
			}
		}
		else {
			echo "Not Logged In";
		}
	}
	function actionRenameItem(){
		if(validateLoggedIn($_SESSION['USERNAME']) == true) {
			valRequestMethodPost();
			$body = inputGetJsonDecode();
			$oldName = arrayGet($body,"OLDNAME");
			$newName = arrayGet($body,"NEWNAME");
			$path = arrayGet($body,"PATH");
			
			$oldItemName = CoreFilePath();
			$oldItemName .= "/".$_SESSION['USERNAME']."".$path."/".$oldName;
			$oldItemName = str_replace("//","/",$oldItemName);
			$newItemName = CoreFilePath();
			$newItemName .= "/".$_SESSION['USERNAME']."".$path."/".$newName;
			$newItemName = str_replace("//","/",$newItemName);
			
			if(file_exists($oldItemName)){
				rename($oldItemName, $newItemName);
			}
			echo "Success";
		}
		else {
			echo "Not Logged In";
		}
	}
	function actionUploadFile(){
		valRequestMethodPost();
		if(validateLoggedIn($_SESSION['USERNAME']) == true) {
			$allFiles = $_FILES;
			$folder = arrayGet($_POST, 'FOLDER');

			$savePath = CoreFilePath().'/'.$_SESSION['USERNAME'].$folder;

			for($i=0; $i<sizeOf($allFiles); $i++){
				$name = $allFiles[$i]['name'];
				$type = $allFiles[$i]['type'];
				$size = $allFiles[$i]['size'];
				$tmpLoc = $allFiles[$i]['tmp_name'];

				move_uploaded_file($tmpLoc, $savePath.'/'.$name);
			}

			echo "Succesfully Uploaded All Files";
		}
		else {
			echo "Not Logged In";
		}
	}
	function actionDownloadItem(){
		valRequestMethodGet();
		if(validateLoggedIn($_SESSION['USERNAME']) == true) {
			$itemName = arrayGet($_GET,"FILENAME");
			$path = arrayGet($_GET,"PATH");
			$username = $_SESSION['USERNAME'];
			
			$downloadItem = CoreFilePath();
			$downloadItem .= "/".$_SESSION['USERNAME']."".$path."".$itemName;
			
			DownloadFile($downloadItem);
			
			//echo 'Success, Item(s) Downloaded To: '.'C:/Users/'.get_current_user().'/Downloads/';
		}
		else {
			echo "Not Logged In";
		}
	}
	function DownloadFile($filePath) {
		set_time_limit(0); // disable the time limit for this script
		
		$pathToSave = 'C:/Users/'.get_current_user().'/Downloads/';
		$path_parts = pathinfo($filePath);
		$writeHandle = $pathToSave;
		$writeHandle .= $path_parts['basename'];

		if(is_dir($filePath) == true){
			$filePath = zipDirectory($filePath);
			$filePath = BackendFilePath().'/'.$filePath;
		}
		 if ($fd = fopen($filePath, "r")) {
	        $fsize = filesize($filePath);
	        $path_parts = pathinfo($filePath);
	        $ext = strtolower($path_parts["extension"]);
	        $header = mimeTypeForExtension($ext);
	        header("Content-Description: File Transfer");
	        header("Content-Transfer-Encoding: binary");
	        header("Content-type: $header");
	        header('Expires: 0');
	        header('Content-disposition: attachment; filename="'.$path_parts["basename"].'"'); // use 'attachment' to force a file download
	        header('Pragma: public');
	        header("Content-length: $fsize");
	        header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
	        header("Cache-control: private", false); //use this to open files directly
	        while(!feof($fd)) {
				$buffer = fread($fd, 2048);
				echo $buffer;
				ob_flush();
        		flush();
			}
			fclose ($fd);
			exit;
		}
	}
	function zipDirectory($folderPath) {
		$path_parts = pathinfo($folderPath);
		$zipName = $path_parts['basename'];
		$zipName = str_replace($zipName, $path_parts['basename'], $path_parts['filename'].'.zip');

		class FlxZipArchive extends ZipArchive {
		    public function addDir($location, $name) {
		        $this->addEmptyDir($name);
		        $this->addDirDo($location, $name);
		     } 

		    private function addDirDo($location, $name) {
		        $name .= '/';
		        $location .= '/';

		        // Read all Files in Dir
		        $dir = opendir ($location);
		        while ($file = readdir($dir))
		        {
		            if ($file == '.' || $file == '..') continue;
		            $do = (filetype( $location . $file) == 'dir') ? 'addDir' : 'addFile';
		            $this->$do($location . $file, $name . $file);
		        }
		    }
		}

		$za = new FlxZipArchive;
		$res = $za->open($zipName, ZipArchive::CREATE);
		if($res === TRUE) 
		{
		    $za->addDir($folderPath, basename($folderPath));
		    $za->close();
		}
		else  { echo 'Could not create a zip archive';}

		$zipFilePath = str_replace($folderPath, $path_parts['basename'], $zipName);
		return $zipFilePath;
	}
	function removeDirectory($directory){
		if(validateLoggedIn($_SESSION['USERNAME']) == true) {
			foreach(glob("{$directory}/*") as $file){
				if(is_dir($file)) { 
					removeDirectory($file);
				} else {
					unlink($file);
				}
			}
			if(is_dir($directory)){
				rmdir($directory);
			}
			else {
				unlink($directory);
			}
		}
		else {
			echo "Not Logged In";
		}
	}
?>